<?php
namespace Claromentis\Infocapture\Filter;

$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"] ?: array()) + array("_b8762acab332819f09c183233ba40a" . "a0" => base64_decode("T2Zmc2V0IGNhbm5vdCBiZSBsZXNzIHRoYW4gemVybywgJw=" . "="), "_f22ff2bb16ab3" . "7d1f01d612e668" . "e64d2" => base64_decode("L" . "C" . "A" . "n"), "_fabe7b83d4fd81224b" . "2616ff59517e4f" => base64_decode("TGltaXQgbXVzdCBiZSBiZXR3ZWVuIDEgYW5k" . "IA=="), "_aa28ebaa9e17fc6a67b37600d92" . "d6054" => base64_decode("Y3JlYXRlZF9kYX" . "Rl"), "_f11369824f53" . "3e8206f9ccc0c" . "9aab3a0" => base64_decode("bGl" . "taX" . "Q="), "_62d701c3c53404f06345eb35720a" . "47b4" => base64_decode("aXNfbnVtZXJpY" . "w=="), "_fa7fe9b4130a69a5ebf1616436603e2" . "7" => base64_decode("JyBnaXZlbi" . "c="), "sta" . "tus" => base64_decode("c3" . "Rh" . "dH" . "Vz"), "_fb092084478a617534a42360c8" . "8e0c9f" => base64_decode("T2Zmc2V0IG11c3" . "QgYmUgYW4gaW50" . "ZWdlciwgJw=="), "_7608a2690229dd26ac43cb60a" . "a2a7d97" => base64_decode("bGFzd" . "F9tb2" . "RpZml" . "lZA=="), "_1f50e30be8c2fefa" . "6881834e71d504a2" => base64_decode("b2Zmc" . "2V0"), "_977995ec9267e034bf7d84b69" . "939eaef" => base64_decode("TGltaXQgbXVz" . "dCBiZSBhbiBp" . "bnRlZ2VyLCAn"));
use Claromentis\Core\Security\SecurityContext;
use Date;
use InvalidArgumentException;
use Psr\Http\Message\ServerRequestInterface;




abstract class AbstractFilter
{
    public const MAX_LIMIT = 200;
    public const DEFAULT_LIMIT = 20;
    
    
    
    
    protected ?SecurityContext $context = null;
    protected int $limit = self::DEFAULT_LIMIT;
    protected int $offset = 0;
    protected ?Date $created_date = null;
    protected ?Date $modified_date = null;
    protected ?string $status = null;
    public function getContext() : ?SecurityContext
    {
        return $this->context;
    }
    public function setContext(?SecurityContext $context = null) : self
    {
        $this->context = $context;
        return $this;
    }
    public function getLimit() : int
    {
        return $this->limit;
    }
    
    
    
    
    
    
    
    
    public function setLimit(int $_f11369824f533e8206f9ccc0c9aab3a0) : self
    {
        if (!$GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_62d701c3c53404f06345eb35720a4" . "7b4"]($_f11369824f533e8206f9ccc0c9aab3a0)) {
            throw new InvalidArgumentException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_977995ec9267e034bf7d84b6993" . "9eaef"] . $_f11369824f533e8206f9ccc0c9aab3a0 . $GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_fa7fe9b4130" . "a69a5ebf1616" . "436603e27"]);
        }
        $_f11369824f533e8206f9ccc0c9aab3a0 = (int) $_f11369824f533e8206f9ccc0c9aab3a0;
        if ($_f11369824f533e8206f9ccc0c9aab3a0 <= 0 || $_f11369824f533e8206f9ccc0c9aab3a0 > self::MAX_LIMIT) {
            throw new InvalidArgumentException($GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_fabe7b83d4fd81224b261" . "6ff59517e4f"] . self::MAX_LIMIT . ($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_f22ff2bb1" . "6ab37d1f01" . "d612e668e6" . "4d2"] . $_f11369824f533e8206f9ccc0c9aab3a0 . $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_fa7fe9b4130a69a5ebf16" . "16436603e27"]));
        } else {
            $this->limit = $_f11369824f533e8206f9ccc0c9aab3a0;
        }
        return $this;
    }
    public function getOffset() : int
    {
        return $this->offset;
    }
    
    
    
    
    
    
    
    
    public function setOffset(int $_1f50e30be8c2fefa6881834e71d504a2) : self
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_62d701c3c53404f06" . "345eb35720a47b4"]($_1f50e30be8c2fefa6881834e71d504a2)) {
            throw new InvalidArgumentException($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_fb092084478a617534a42360c8" . "8e0c9f"] . $_1f50e30be8c2fefa6881834e71d504a2 . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_fa7fe9b4130a69a5ebf16164366" . "03e27"]);
        }
        $_1f50e30be8c2fefa6881834e71d504a2 = (int) $_1f50e30be8c2fefa6881834e71d504a2;
        if ($_1f50e30be8c2fefa6881834e71d504a2 < 0) {
            throw new InvalidArgumentException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_b8762acab332819f" . "09c183233ba40aa0"] . $_1f50e30be8c2fefa6881834e71d504a2 . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_fa7fe9b4130a69a" . "5ebf1616436603e2" . "7"]);
        }
        $this->offset = $_1f50e30be8c2fefa6881834e71d504a2;
        return $this;
    }
    public function getCreatedDate() : ?Date
    {
        return $this->created_date;
    }
    public function setCreatedDate(?Date $_aa28ebaa9e17fc6a67b37600d92d6054)
    {
        $this->created_date = $_aa28ebaa9e17fc6a67b37600d92d6054;
    }
    public function getModifiedDate() : ?Date
    {
        return $this->modified_date;
    }
    public function setModifiedDate(?Date $_aeb918f309c1ac9bf44d7449ee69a709)
    {
        $this->modified_date = $_aeb918f309c1ac9bf44d7449ee69a709;
    }
    public function getStatus() : ?string
    {
        return $this->status;
    }
    public function setStatus(?string $status) : void
    {
        $this->status = $status;
    }
    
    
    
    
    
    
    
    
    public function setPaginationAttributesFromRequest(ServerRequestInterface $request) : void
    {
        $parameters = $request->getQueryParams();
        $_1f50e30be8c2fefa6881834e71d504a2 = isset($parameters[$GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_1f50e30be8c2fefa6881834e71d5" . "04a2"]]) && $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_62d701c3c" . "53404f0634" . "5eb35720a4" . "7b4"]($parameters[$GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_1f50e30be8c2fefa6881" . "834e71d504a2"]]) ? (int) $parameters[$GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_1f50e30be8c2fefa6" . "881834e71d504a2"]] : 0;
        $_f11369824f533e8206f9ccc0c9aab3a0 = isset($parameters[$GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_f11369824f533e8206f9cc" . "c0c9aab3a0"]]) && $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_62d701c3c5" . "3404f06345e" . "b35720a47b4"]($parameters[$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_f11369824f533e8206f" . "9ccc0c9aab3a0"]]) ? (int) $parameters[$GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_f11369824f533e820" . "6f9ccc0c9aab3a0"]] : self::DEFAULT_LIMIT;
        $this->setOffset($_1f50e30be8c2fefa6881834e71d504a2);
        $this->setLimit($_f11369824f533e8206f9ccc0c9aab3a0);
    }
    
    
    
    
    
    
    public function toArray() : array
    {
        return [$GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_f11369824f533e8206f9ccc" . "0c9aab3a0"] => $this->limit, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_1f50e30be8" . "c2fefa68818" . "34e71d504a2"] => $this->offset, $GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_aa28ebaa9e17f" . "c6a67b37600d92" . "d6054"] => $this->created_date, $GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_7608a2690229dd26ac43" . "cb60aa2a7d97"] => $this->modified_date, $GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["stat" . "us"] => $this->status];
    }
}